config/routes.rb
Rails.application.routes.draw do
  resources :client_measure_histories
  resources :training_clients
  resources :repetitions
  resources :numbers
  resources :exercises
  resources :equipaments
  resources :client_payment_histories
  resources :clients
  #resources :plan_service_clients
  resources :service_clients
  resources :plan_clients
  resources :gym_payment_histories
  resources :coaches
  resources :gyms
  #resources :plan_service_managers
  resources :service_managers
  resources :plan_managers
  resources :managers
  resources :admins

  root to: 'application#home'

  devise_for :users, path: '', path_names: { sign_in: 'login', sign_out: 'logout', sign_up: 'register', edit: 'settings' }
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

  get '/home', to: 'application#home', as: 'home'
  get '/secret', to: 'application#secret', as: 'secret'

  get '/manager_clients', to: 'managers#show_clients'
  get '/manager_coaches', to: 'managers#show_coaches'

  get '/admin_managers', to: 'admins#show_managers'
  get '/admin_managers/:email', to: 'admins#show_manager'
  get '/gym_payments/:id',  to: 'gyms#payments'

  # token auth routes available at /api_application/mobile/auth
  namespace :api_application do
    scope :mobile do
      mount_devise_token_auth_for 'UserMobile', at: 'auth'
    end
  end

  devise_scope :user_mobile do
    get 'api_application/mobile/mobile_profile', to: 'mobile#mobile_profile'
    get 'api_application/mobile/profile_payments', to: 'mobile#profile_payments'
    get 'api_application/mobile/profile_training', to: 'mobile#profile_training'
    get 'api_application/mobile/profile_measures', to: 'mobile#profile_measures'

  end

end

app/models/admin.rb
class Admin < ApplicationRecord
  belongs_to :user
end

app/models/client.rb
class Client < ApplicationRecord
  belongs_to :user
  belongs_to :gym
  belongs_to :plan_client

  has_many :client_payment_histories
  has_many :training_clients
  has_many :client_measure_histories
end

app/models/coach.rb
class Coach < ApplicationRecord
  belongs_to :user
  belongs_to :gym

  has_many :trainings
end

app/models/equipament.rb
class Equipament < ApplicationRecord
  belongs_to :gym

  has_many :trainings
end

app/models/exercise.rb
class Exercise < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/gym.rb
class Gym < ApplicationRecord
  belongs_to :manager
  belongs_to :plan_manager

  has_many :coaches
  has_many :gym_payment_histories
  has_many :clients
  has_many :service_clients
  has_many :equipaments
  has_many :exercises
  has_many :numbers
  has_many :repetitions

end

app/models/manager.rb
class Manager < ApplicationRecord
  belongs_to :user
  has_many :gyms
end

app/models/measure.rb
class Measure < ApplicationRecord
  has_many :client_measure_histories
end

app/models/muscle_type.rb
class MuscleType < ApplicationRecord

  has_many :trainings

end

app/models/number.rb
class Number < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/plan_client.rb
class PlanClient < ApplicationRecord
  belongs_to :gym

  has_many :plan_service_clients
  has_many :clients

end

app/models/plan_manager.rb
class PlanManager < ApplicationRecord
  has_many :plan_service_managers
  has_one :gym
end

app/models/repetition.rb
class Repetition < ApplicationRecord
  belongs_to :gym

  has_many :trainings

end

app/models/service_client.rb
class ServiceClient < ApplicationRecord
  belongs_to :gym
  has_many :plan_service_clients
end

app/models/training.rb
class Training < ApplicationRecord
  belongs_to :coach
  belongs_to :equipament
  belongs_to :exercise
  belongs_to :number
  belongs_to :repetition
  belongs_to :muscle_type
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable


  has_many :admis
  has_many :Managers
  has_many :coaches
  has_many :clients
end

app/models/user_mobile.rb
class UserMobile < ActiveRecord::Base
  # Include default devise modules.
  devise :database_authenticatable, :registerable,
          :recoverable, :rememberable, :trackable, :validatable,
          #:confirmable,
          :omniauthable
  include DeviseTokenAuth::Concerns::User

  def self.is_valid_token(token, client_id)
    @resource.valid_token?(token, client_id)
  end

end

app/helpers/admins_helper.rb
module AdminsHelper
end

app/helpers/gyms_helper.rb
module GymsHelper
end

app/helpers/mobile_helper.rb
module MobileHelper
end

app/views/admins/_form.html.erb
<%= form_with(model: admin, local: true) do |form| %>
  <% if admin.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(admin.errors.count, "error") %> prohibited this admin from being saved:</h2>

      <ul>
      <% admin.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :user_id %>
    <%= form.text_field :user_id, id: :admin_user_id %>
  </div>

  <div class="field">
    <%= form.label :name %>
    <%= form.text_field :name, id: :admin_name %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/admins/edit.html.erb
<h1>Editing Admin</h1>

<%= render 'form', admin: @admin %>

<%= link_to 'Show', @admin %> |
<%= link_to 'Back', admins_path %>

app/views/admins/index.html.erb
<html>
<title>Academy</title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Raleway">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<style>
html,body,h1,h2,h3,h4,h5 {font-family: "Raleway", sans-serif}
</style>
<body class="w3-light-grey">

<!-- Top container -->
<div class="w3-bar w3-top w3-black w3-large" style="z-index:4">
  <button class="w3-bar-item w3-button w3-hide-large w3-hover-none w3-hover-text-light-grey" onclick="w3_open();"><i class="fa fa-bars"></i>  Menu</button>
  <div class="w3-bar-item w3-right">
    <a rel="nofollow" data-method="delete" href="/logout" class="fa fa-sign-out" aria-hidden="true"></a>
  </div>
</div>

<!-- Sidebar/menu -->
<nav class="w3-sidebar w3-collapse w3-white w3-animate-left" style="z-index:3;width:300px;" id="mySidebar"><br>
  <div class="w3-container w3-row">
    <div class="w3-col s4">
      <!-- <img src="/w3images/avatar2.png" class="w3-circle w3-margin-right" style="width:46px"> -->
    </div>
    <div class="w3-col s8 w3-bar">
      <span>Bem vindo, <strong><%= @admin.name %></strong></span><br>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-envelope"></i></a>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-user"></i></a>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-cog"></i></a>
    </div>
  </div>
  <hr>
  <div class="w3-container">
    <h5>Dashboard</h5>
  </div>
  <div class="w3-bar-block">
    <a href="#" class="w3-bar-item w3-button w3-padding-16 w3-hide-large w3-dark-grey w3-hover-black" onclick="w3_close()" title="close menu"><i class="fa fa-remove fa-fw"></i>  Close Menu</a>
    <a href="/" class="w3-bar-item w3-button w3-padding w3-blue"><i class="fa-home"></i>  home</a>
    <a href="plan_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-eye fa-fw"></i>  Planos</a>
    <a href="service_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-eye fa-fw"></i>  Serviços</a>
    <a href="admin_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-users fa-fw"></i>  Gerentes</a>
    <a href="gyms" class="w3-bar-item w3-button w3-padding"><i class="fa fa-bullseye fa-fw"></i>  Academias</a>
    <a href="gym_payment_histories" class="w3-bar-item w3-button w3-padding"><i class="fa fa-diamond fa-fw"></i>  Pagamentos</a>
    <a href="#" class="w3-bar-item w3-button w3-padding"><i class="fa fa-cog fa-fw"></i>  Configurações</a><br><br>
    <a href="/logout" class="w3-bar-item w3-button w3-padding" rel="nofollow" data-method="delete"><i  class="fa fa-sign-out"></i>  Sair</a><br><br>
  </div>
</nav>


<!-- Overlay effect when opening sidebar on small screens -->
<div class="w3-overlay w3-hide-large w3-animate-opacity" onclick="w3_close()" style="cursor:pointer" title="close side menu" id="myOverlay"></div>

<!-- !PAGE CONTENT! -->
<div class="w3-main" style="margin-left:300px;margin-top:43px;">

  <!-- Header -->
  <header class="w3-container" style="padding-top:22px">
    <h5><b><i class="fa fa-dashboard"></i> My Dashboard</b></h5>
  </header>

  <div class="w3-row-padding w3-margin-bottom">
    <div class="w3-quarter">
      <div class="w3-container w3-red w3-padding-16">
        <div class="w3-left"><i class="fa fa-comment w3-xxxlarge"></i></div>
        <div class="w3-right">
          <h3><%= @gyms.size %></h3>
        </div>
        <div class="w3-clear"></div>
        <h4>Academias</h4>
      </div>
    </div>
    <div class="w3-quarter">
      <div class="w3-container w3-blue w3-padding-16">
        <div class="w3-left"><i class="fa fa-eye w3-xxxlarge"></i></div>
        <div class="w3-right">
          <h3><%= @coaches.size %></h3>
        </div>
        <div class="w3-clear"></div>
        <h4>Profissionais</h4>
      </div>
    </div>
    <div class="w3-quarter">
      <div class="w3-container w3-teal w3-padding-16">
        <div class="w3-left"><i class="fa fa-users w3-xxxlarge"></i></div>
        <div class="w3-right">
          <h3><%= @clients.size %></h3>
        </div>
        <div class="w3-clear"></div>
        <h4>Clientes</h4>
      </div>
    </div>
  </div>

  <!-- Content -->

  <!-- Content -->

  <!-- Footer -->
  <footer class="w3-container w3-padding-16 w3-light-grey">
    <p>All rights reserved Version: beta </p>
  </footer>

  <!-- End page content -->
</div>

<script>
// Get the Sidebar
var mySidebar = document.getElementById("mySidebar");

// Get the DIV with overlay effect
var overlayBg = document.getElementById("myOverlay");

// Toggle between showing and hiding the sidebar, and add overlay effect
function w3_open() {
    if (mySidebar.style.display === 'block') {
        mySidebar.style.display = 'none';
        overlayBg.style.display = "none";
    } else {
        mySidebar.style.display = 'block';
        overlayBg.style.display = "block";
    }
}

// Close the sidebar with the close button
function w3_close() {
    mySidebar.style.display = "none";
    overlayBg.style.display = "none";
}
</script>

</body>
</html>

app/views/admins/new.html.erb
<h1>New Admin</h1>

<%= render 'form', admin: @admin %>

<%= link_to 'Back', admins_path %>

app/views/admins/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>User:</strong>
  <%= @admin.user %>
</p>

<p>
  <strong>Name:</strong>
  <%= @admin.name %>
</p>

<%= link_to 'Edit', edit_admin_path(@admin) %> |
<%= link_to 'Back', admins_path %>

app/views/admins/show_manager.html.erb
<div class="content-wrapper">
  <!-- Content Header (Page header) -->
  <section class="content-header">
    <ol class="breadcrumb">
      <li><a href="/admin_managers"><i class="fa fa-dashboard"></i>Home</a></li>
      <li class="active"><%= @manager.name %></li>
    </ol>
  </section>

    <div class="row">
      <section class="col-lg-12 connectedSortable">
        <table class="table table-hover">
          <thead>
            <tr>
              <th>Nome</th>
              <th>Email</th>
              <th colspan="6"></th>
            </tr>
          </thead>

          <tbody>
              <tr>
                <td><%= @manager.name %></td>
                <td><%= @manager.user.email %></td>
              </tr>
          </tbody>
        </table>
      </section>
    </div>


  </section>
</div>
</div>
<!-- ./wrapper -->

app/views/admins/show_managers.html.erb
<html>
<title>Academy</title>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="stylesheet" href="https://www.w3schools.com/w3css/4/w3.css">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Raleway">
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
<style>
html,body,h1,h2,h3,h4,h5 {font-family: "Raleway", sans-serif}
</style>
<body class="w3-light-grey">

<!-- Top container -->
<div class="w3-bar w3-top w3-black w3-large" style="z-index:4">
  <button class="w3-bar-item w3-button w3-hide-large w3-hover-none w3-hover-text-light-grey" onclick="w3_open();"><i class="fa fa-bars"></i>  Menu</button>
  <div class="w3-bar-item w3-right">
    <a rel="nofollow" data-method="delete" href="/logout" class="fa fa-sign-out" aria-hidden="true"></a>
  </div>
</div>

<!-- Sidebar/menu -->
<nav class="w3-sidebar w3-collapse w3-white w3-animate-left" style="z-index:3;width:300px;" id="mySidebar"><br>
  <div class="w3-container w3-row">
    <div class="w3-col s4">
      <img src="/w3images/avatar2.png" class="w3-circle w3-margin-right" style="width:46px">
    </div>
    <div class="w3-col s8 w3-bar">
      <span>Bem vindo, <strong><%= @admin.name %></strong></span><br>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-envelope"></i></a>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-user"></i></a>
      <a href="#" class="w3-bar-item w3-button"><i class="fa fa-cog"></i></a>
    </div>
  </div>
  <hr>
  <div class="w3-container">
    <h5>Dashboard</h5>
  </div>
  <div class="w3-bar-block">
    <a href="#" class="w3-bar-item w3-button w3-padding-16 w3-hide-large w3-dark-grey w3-hover-black" onclick="w3_close()" title="close menu"><i class="fa fa-remove fa-fw"></i>  Close Menu</a>
    <a href="/" class="w3-bar-item w3-button w3-padding"><i class="fa-home"></i>  home</a>
    <a href="plan_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-eye fa-fw"></i>  Planos</a>
    <a href="service_managers" class="w3-bar-item w3-button w3-padding"><i class="fa fa-eye fa-fw"></i>  Serviços</a>
    <a href="admin_managers" class="w3-bar-item w3-button w3-padding w3-blue"><i class="fa fa-users fa-fw"></i>  Gerentes</a>
    <a href="gyms" class="w3-bar-item w3-button w3-padding"><i class="fa fa-bullseye fa-fw"></i>  Academias</a>
    <a href="gym_payment_histories" class="w3-bar-item w3-button w3-padding"><i class="fa fa-diamond fa-fw"></i>  Pagamentos</a>
    <a href="#" class="w3-bar-item w3-button w3-padding"><i class="fa fa-cog fa-fw"></i>  Configurações</a><br><br>
    <a href="/logout" class="w3-bar-item w3-button w3-padding" rel="nofollow" data-method="delete"><i  class="fa fa-sign-out"></i>  Sair</a><br><br>
  </div>
</nav>


<!-- Overlay effect when opening sidebar on small screens -->
<div class="w3-overlay w3-hide-large w3-animate-opacity" onclick="w3_close()" style="cursor:pointer" title="close side menu" id="myOverlay"></div>

<!-- !PAGE CONTENT! -->
<div class="w3-main" style="margin-left:300px;margin-top:43px;">

  <!-- Content -->

  <div class="row" style="padding-top:22px">
    <!-- Left col -->
    <section class="col-lg-12 connectedSortable" style="padding-left:30px">
      <!-- Main row -->
      <div class="row">
        <div class="col-lg-6">
          <form action="/admin_managers/:email" accept-charset="UTF-8" method="get">
            <div class="input-group">
              <input type="text" class="form-control" placeholder="email"  autofocus="autofocus" name="manager[email]" id="manager_email">
              <span class="input-group-btn">
                <button class="btn btn-secondary" type="submit">Pesquisar</button>
              </span>
            </div>
          </form>
        </div>
      </div>
      <!-- /.row (main row) -->

      <div class="row">
        <table class="table table-hover">
          <thead>
            <tr>
                <th>Nome</th>
                <th>Email</th>
                <th>Phone</th>
                <th colspan="6"></th>
            </tr>
          </thead>

          <tbody>
            <% @managers.each do |m| %>
              <tr>
                <td><%= m.name %></td>
                <td><%= m.user.email %></td>
                <td><%= m.phone %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      </div>
  <!-- /.row (main row) -->
  <% if @admin%>
    <div class="row">
      <div class="col-lg-offset-5 col-lg-2">
        <a href="/managers/new" class="btn btn-primary" role="button">Novo gerente</a>
      </div>
    </div>
  <% end %>
  <!-- Content -->

  <!-- Footer -->
  <footer class="w3-container w3-padding-16 w3-light-grey">
    <p>All rights reserved Version: beta </p>
  </footer>

  <!-- End page content -->
</div>

<script>
// Get the Sidebar
var mySidebar = document.getElementById("mySidebar");

// Get the DIV with overlay effect
var overlayBg = document.getElementById("myOverlay");

// Toggle between showing and hiding the sidebar, and add overlay effect
function w3_open() {
    if (mySidebar.style.display === 'block') {
        mySidebar.style.display = 'none';
        overlayBg.style.display = "none";
    } else {
        mySidebar.style.display = 'block';
        overlayBg.style.display = "block";
    }
}

// Close the sidebar with the close button
function w3_close() {
    mySidebar.style.display = "none";
    overlayBg.style.display = "none";
}
</script>

</body>
</html>